"use strict";

exports.__esModule = true;
exports.Consumer = void 0;
var _preact = require("preact");
var _react = require("../../react");
function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
var canUseDOM = !!(typeof window !== 'undefined' && window.document && window.document.createElement);
var Consumer = exports.Consumer = /*#__PURE__*/function (_Component) {
  _inheritsLoose(Consumer, _Component);
  function Consumer(props, _ref) {
    var _this;
    var atom = _ref.atom;
    _this = _Component.call(this) || this;
    _this.state = _this.map(atom.get(), props);
    _this.shouldObserve = typeof props.observe === 'undefined' ? canUseDOM : props.observe;
    _this.scheduleUpdate = function () {
      return _this.update();
    };
    return _this;
  }
  var _proto = Consumer.prototype;
  _proto.observe = function observe() {
    var _this2 = this;
    if (!this.shouldObserve) return;
    var atom = this.context.atom;
    this.unobserve && this.unobserve();
    this.unobserve = atom.observe(function () {
      _this2.cancelUpdate = _this2.scheduleUpdate();
    });
    this.observedAtom = atom;
  };
  _proto.componentWillUnmount = function componentWillUnmount() {
    this.unobserve && this.unobserve();
    this.cancelUpdate && this.cancelUpdate();
    delete this.unobserve;
    delete this.cancelUpdate;
    delete this.observedAtom;
  };
  _proto.shouldComponentUpdate = function shouldComponentUpdate(nextProps, nextState) {
    if (!this.isPure) return true;

    // if it's <Consumer> with dynamic children, shortcut the check
    if (this.props.children !== nextProps.children) {
      return true;
    }

    // our state is mappedProps, this is the main optimisation
    if ((0, _react.differs)(this.state, nextState)) {
      return true;
    }

    // in connect() case don't need to diff further, no extra props
    if (this.props.originalProps) {
      this.cancelUpdate && this.cancelUpdate();
      return false;
    }

    // in <Consumer /> case we also diff props
    if ((0, _react.differs)(this.props, nextProps)) {
      return true;
    }
    this.cancelUpdate && this.cancelUpdate();
  }

  // eslint-disable-next-line react/no-deprecated
  ;
  _proto.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    var atom = this.context.atom;
    var nextMappedProps = this.map(atom.get(), nextProps);
    this.setState(nextMappedProps);
  };
  _proto.componentDidUpdate = function componentDidUpdate() {
    this.cancelUpdate && this.cancelUpdate();
  };
  _proto.map = function map(state, props) {
    var originalProps = props.originalProps,
      map = props.map;
    return Object.assign({}, originalProps, map ? map(state, originalProps) : {});
  };
  _proto.update = function update() {
    var atom = this.context.atom;
    var nextMappedProps = this.map(atom.get(), this.props);
    this.setState(nextMappedProps);
  };
  _proto.render = function render(_ref2, state, _ref3) {
    var originalProps = _ref2.originalProps,
      _render = _ref2.render,
      children = _ref2.children;
    var atom = _ref3.atom;
    // do this in render, because:
    //  doing in constructor would cause memory leaks in SSR
    //  doing in componentDidMount leads to the wrong order of subscriptions
    //  we don't have another hook in Preact's context to check if atom was swapped
    if (!this.unobserve || this.observedAtom !== atom) this.observe();
    var actions = atom.actions,
      dispatch = atom.dispatch;
    var mappedProps = this.state;
    return (_render || children[0])(Object.assign({}, originalProps, {
      actions: actions,
      dispatch: dispatch
    }, mappedProps));
  };
  return Consumer;
}(_preact.Component);